/*
                 Copyright(c) 2005 Toufik Sarni

This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA*/


#include <kernel.h>
void init_pic(){    
                        //Veuillez consulter la documentation sur les ports (ports.lst) dans intelref, pour plus de dtails

    print("initialisation du PIC 8259A...\n");
                         
    outpb (0x20,0x11);   //initialiser le ICW1 du maitre et utiliser ICW4
    outpb (0xA0,0x11);   //ce de l'escalve

  asm{
    jmp $+2              //saut  la prochaine instruction, a sert de dlai pour le PIC
    jmp $+2
     }                   /*nous voulons utiliser les IT des IRQ  partir de 0x50 donc*/
   outpb(0x21,0x50);     /*0x50 reprsente le veteur d'IT du IRQ0, 0x51 du IRQ1 etc... jusqu' 0x57 qui est celle du IRQ7*/
   outpb(0xA1,0x60);

   asm{
    jmp $+2
    jmp $+2
      }
    outpb (0x21,4);    //ICW3 Maitre
    outpb (0xA1,2);    //ICW3 Esclave

  asm{
    jmp $+2            //attente
    jmp $+2
     }
    outpb(0x21,1);   //ICW4 Maitre
    outpb(0xA1,1);   //ICW4 Esclave


}
void masquage_it(u8 ICW2_Master,u8 ICW2_Esclave)
 {
  print("Masquage d'interruptions...\n");
  outpb (0x21,ICW2_Master);
  outpb (0xA1,ICW2_Esclave);

 }
