/*
                 Copyright(c) 2005 Toufik Sarni

This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA*/

#include <kernel.h>
#include <proc.h>


void main(){
 
 bascul(0x63000);         //mettre en place le basculeur  l'@ du paramtre; doit tre execut en premier

 printk("\nMode 32-bit:  [",i_blanc);
 printk("activ",i_vert);
 printk("]\n",i_blanc);

 init_idt();              //initialiser la table des vecteurs d'IT  0x50000
 init_pic();              //initialiser le pic

#ifdef TEMPS_REEL
        masquage_it(0xF9,0xFE);
        printk("\n                 Chargement du Module Temps Rel: [",i_blanc);
        printk("OK",cli_i_vert);
        printk("]\n\n",i_blanc);
        __frq_cpu();
        init_file_sem();
       application_tr();
#endif

#ifdef TEMPS_PARTAGE
          module_tpartage();
#endif

asm{
    sti
    }
while(1);
}


