/*
                 Copyright(c) 2005 Toufik Sarni

This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA*/


#include <kernel.h>
#include <proc.h>

/*************************************************************************/
thread1()
{
  while(1);
}

thread2()
{
  while(1);
}

thread3()
{
  while(1);
}
/**************************************************************************/

void application_tr()
{
  int i,j,k,l;

  i=creer_tache((THREAD)&thread1,0,1,4,0);
  if (i<0) print_rt("Erreur -%d: Cration de Thread1\n",-i);

  j=creer_tache((THREAD)&thread2,0,2,6,0);
  if (i<0) print_rt("Erreur -%d: Cration de Thread2\n",-i);

  k=creer_tache((THREAD)&thread3,0,3,8,0);
  if (k<0) print_rt("Erreur -%d: Cration de Thread3\n",-k);

  l=faisabilite();     //test de faisabilit RM
   if (l<0) print_rt("Faisabilit erreur: -%d\n",-l);
       else print_rt("Faisabilit ... OK\n");

  activer_horloge();
  while(1);
}
