/*
                 Copyright(c) 2005 Toufik Sarni

This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA*/

#include <kernel.h>
#include <memory.h>
#include <proc.h>

void module_tpartage()
{
  masquage_it(0xF8,0xFE);
 init_paging();
 init_memory();

 init_timer();
 init_process();

 print("Cration de 4 processus...\n");
 creer_processus("processus1",50);
 print("    Nom: Processus1  taille: 50KO  ... OK\n"),
 creer_processus("processus2",167);
 print("    Nom: Processus2  taille: 167KO  ... OK\n"),

 creer_processus("processus3",1024);
 print("    Nom: Processus3  taille: 1MO ... OK\n"),

 creer_processus("processus4",2048);
 print("    Nom: Processus4  taille: 2MO  ... OK\n"),

 print("Memoire libre: %dK\n",mem_libre());
 print("Activation des interruptions...\n\nParlez on vous coute...->");
 outpb(0x20,0x20);
 outpb(0xa0,0x20);
 asm sti;
 while(1);

}
