/*
                 Copyright(c) 2005 Toufik Sarni

This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA*/

#include <kernel.h>

/* on dclare les suivantes variables comme globales, afin qu'elles puissent avoir
 * une adresse dans la partie DATA du code, (convention C), sinon leurs adresses
 * seront couverte par celle de la pile.
 */

char buff_decasc[10];     // pour unsigned long, on a 10 chiffres en dcimal, pour la + grande valeur
char buff_temp_decasc[10];

const char _fptr * decasc(unsigned long i)
   { 
     int cpt=0;
     char *ptr=&buff_decasc[0],*temp=&buff_temp_decasc[0];

     if (i==0) {           // pour le cas nul.
        *ptr=(char)0x30;
        *(ptr+1)=0;
        return ptr;
                }

  while (i !=0)
   {
     cpt++;
     *temp=i%10;        // "temp" va contenir sur chaque caractre, un chiffre dcimal, partant du poids faible au poids fort.
     temp++;
     i /=10;
   }
     temp--;i=1;       // on dcremente "temp" pour pointer sur le dernier chiffre (poids fort)
     while (cpt>=(int)i)  // "cpt" contient le nombre de chiffres
      {
       *ptr=*temp+(char)0x30;  //"ptr" va contenir le chiffre en ASCII, mais cette fois ci partant du poids fort au poids faible 
       ptr++;temp--;
       i++;
      }
       *ptr=0; /*fin de la chane de caractre */
   return &buff_decasc[0];
   }
