/*
                 Copyright(c) 2005 Toufik Sarni

This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA*/

#include <kernel.h>

char buffer_hexasc[32];   //nous ferons convertir au max 16*2 chiffres

const char _fptr * hexasc(const char _fptr * ptr,int cpt)
{  
  if (cpt>16) cpt=16;     //16 chiffres hEX au max  faire retourner
  char *txt="0123456789ABCDEF";
  char *temp=&buffer_hexasc[0];
  int j;

for(j=1;j<=cpt;j++,temp+=2,ptr++)
 {
  *temp=txt[(*ptr & 0xF0)>>4]; //Masque pour tirer les 4-bits forts, puis faire une rotation  droite
  *(temp+1)=txt[(*ptr & 0x0F)]; //tirer les 4-bits du poids faible

 }
 *temp=0; //fin de chaine
 return &buffer_hexasc[0];
}

/* la fonction suivante, idem  la premire, sauf qu'elle parcours
 * du plus fort poids au plus faible.(d'une manire inverse)
 */

const char _fptr * hexascinv(const char _fptr * ptr,int cpt)
  { 
  char *txt="0123456789ABCDEF";
  char *temp=&buffer_hexasc[0];
  ptr+=cpt-1;  //pointer vers le plus fort poids
  int j;

   for(j=1;j<=cpt;j++,temp+=2,ptr--)
   {
    *temp=txt[(*ptr & 0xF0)>>4]; //Masque pour tirer les 4 bits forts, puis faire une rotation  droite
    *(temp+1)=txt[(*ptr & 0x0F)];
   }
 *temp=0; //fin de chaine
 return &buffer_hexasc[0];
}
