#include <bios.h>
#include <stdio.h>
#define __DISQUE_DUR__

int main(void)
{
  struct diskinfo_t dinfo;
  int result;
  unsigned char dbuf[512];
  printf("Programme d'installation version 1.0 \n");

  #ifdef __DISQUETTE__
  printf("-------------------------------------\n");
  printf("Installation du systme sur disquette\n");
  printf("--------------------------------------\n");


  dinfo.drive =  0;    /* drive number for A: */
  dinfo.head  =  0;    /* disk head number */
  dinfo.track =  0;    /* track number */
  dinfo.sector  =  1;  /* sector number */
  dinfo.nsectors =  1; /* sector count */
  dinfo.buffer = dbuf; /* data buffer */

  printf("Attempting to read from drive A:\n");
  result = _bios_disk(_DISK_READ, &dinfo);
  if ((result & 0xff00) == 0)
  {
    printf("Disk read from A: successful.\n");
    printf("First three bytes read are 0x%02x 0x%02x 0x%02x\n",
      dbuf[0] & 0xff, dbuf[1] & 0xff, dbuf[2] & 0xff);
  }
  else
    printf("Cannot read drive A, status = 0x%02x\n", result);
  #endif



 #ifdef __DISQUE_DUR__

 char nom_partition[255][25]={"","Inutilise","FAT12","","","FAT16 < 32MB","EXTENTED","FAT16","NTFS / HPFS","","","OS/2 BM / Coher swp","FAT32","FAT32 (Bios.Ext)","","FAT16 (Bios.Ext)","Ext. Part (Bios. Ext)","","","","","","","","NTFS5","AST SWAP","","","","","","FAT16 (Win ME)","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","Partition Magic","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","Disk secure Multiboot","","","","","","","","","","","","","","","","Linux","Linux","Linux swap/Solaris","Linux Ext2(native)","","Linux extented","NTFS FAT16","NTFS/HPFS mirror"};


 printf("---------------------------------------\n");
 printf("Installation sur disque dur en cours...\n");
 printf("---------------------------------------\n");
 printf("\nLecture du MBR, disque dur 0\n");
  dinfo.drive =  0x80;    /* drive number for A: */
  dinfo.head  =  0;    /* disk head number */
  dinfo.track =  0;    /* track number */
  dinfo.sector  =  1;  /* sector number */
  dinfo.nsectors =  1; /* sector count */
  dinfo.buffer = dbuf; /* data buffer */

  result = _bios_disk(_DISK_READ, &dinfo);
  if ((result & 0xff00) == 0)
  {
     if (((dbuf[0x1fe])==(unsigned char)(0x55)) && ((dbuf[0x1ff])==(unsigned char)(0xaa))) {
       printf("Liste des partition trouves:\n\n");
       int nbrpart=0;
       printf("___________________________________________\n");       
       printf("Partition:\t|\tIntitul:\n");
       printf("-------------------------------------------\n");
       for (;nbrpart<=3;nbrpart++)
          {
       printf("   %d      \t|\t%s\n",nbrpart,&nom_partition[dbuf[0x1c2+(nbrpart*16)]][25]);
           }
       printf("___________________________________________\n\n");
       int choix=0;
       printf("\nSur quelle partition reconnue, voulez-vous installer le systme ?[0-3]: ");
       scanf("%d",&choix);
       if ((choix >=0) && (choix <=3)) printf("Partion %d slctionne",choix);

  }
  else
    {printf("Problme 0x%02x\n rencontr sur le disque dur. Echec!", result); goto echec;}
    
          }
 #endif
echec:
  return 0;
}
