title basculeur

.model tiny,c

extrn _printk:near
extrn _putchr:near
extrn _write:near
extrn _read:near


.code
  .386p
bascul proc uses si di es ds, adr:dword
jmp debut

debut_copie:
  cli

  mov eax,cr0
  and eax,7fffffffh ; pour dsacticer la pagination (le bit 31  PG)
  mov cr0,eax       ;

  mov ax,20h
  mov ds,ax
  mov es,ax
  mov ss,ax

  mov eax,cr0
  and al,0feh
  mov cr0,eax  ; mode reel

db 0eah   ;
dw $-debut_copie+4    ;  jmp far 6000:$+4
dw 6000h  ;

  mov ax,6000h
  mov ds,ax
  mov ss,ax
  mov sp,0fff0h
  mov si,idtr_reel-debut_copie
  lidt fword ptr ds:[si]

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; prsent nous allons lire le type de la fonction
;qui est  l'adresse 9000h:0050h; on note que les 40h premiers octets
;du segment 9000h, prsrvent le contexte, pour assurer le bon retour
;au mode 32-bit
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

mode16:
      mov ax,9000h
      mov es,ax
      mov ah,byte ptr es:[100h]

     .if (ah==1) ; <=> la fonction _printk(string far adresse, char couleur)
       push word ptr es:[102h]
       push 90000200h  ; 9000h:0200h est l'adresse du buffer des fonctions
       db 09ah
       dw _printk  
       dw 2000h    ;call far __printk

     .endif

     .if (ah==2); <=> la fonction _putchr(char chr,char couleur,int cpt)
       push word ptr es:[102h] ; int cpt
       push word ptr es:[104h] ; char couleur
       push word ptr es:[106h] ; char chr
       db 09ah
       dw _putchr
       dw 2000h   ;call far __putchr
     .endif  

     .if (ah==3); <=> la fonction _write(u8 lect, u16 cyl,u16 tete, u16 sect,nbr_sect,adresse)
       push 090000200h ; adresse du buffer
       push 1  ; un seul secteur  crire
       push word ptr es:[102h] ; sect
       push word ptr es:[104h] ; tete
       push word ptr es:[106h] ; cyl
       push word ptr es:[108h] ; lect
       db 09ah
       dw _write
       dw 2000h   ;call far __write
       .if (ax != 0) ;si succs
           push 9000h
           pop es
           mov cx,0aa55h
           mov word ptr es:[400h],cx
       .else
           push 9000h
           pop es
           xor cx,cx
           mov word ptr es:[400h],cx
       .endif

     .endif

     .if (ah==4); <=> la fonction _read(u8 lect, u16 cyl,u16 tete, u16 sect,nbr_sect,adresse)
       push 090000200h ; adresse du buffer
       push 1  ; un seul secteur  lire
       push word ptr es:[102h] ; sect
       push word ptr es:[104h] ; tete
       push word ptr es:[106h] ; cyl
       push word ptr es:[108h] ; lecteur

       db 09ah
       dw _read
       dw 2000h   ;call far __read
       
       .if (ax != 0) ;si succs
           push 9000h
           pop es
           mov cx,0aa55h
           mov word ptr es:[400h],cx
       .else
           push 9000h
           pop es
           xor cx,cx
           mov word ptr es:[400h],cx
       .endif

     .endif  


     mov eax,cr0
     or al,01
     mov cr0,eax
     jmp $+2
     mov ax,10h
     mov ds,ax
     mov es,ax
     mov ss,ax
     db 66h,0eah
     dd 063000h        ; retour au basculeur 32-bit
     dw 08
     dw ?
idtr_reel:
       dw 03ffh
       db 0000
  fin_copie:

;///////////////////////////////////////////////////////////////////////

      debut:   ; on copie la procdure bascul  l'@ adr

      les di,dword ptr adr
      mov si,debut_copie
      mov cx,fin_copie-debut_copie
      rep movsb

ret
bascul endp
end
