.model tiny,c
.code
.586
init_cpu proc uses  ebx ecx nbr:byte
 xor ebx,ebx
 xor ecx,ecx
 xor edx,edx
 xor eax,eax
    .if (nbr==0)
   cpuid  ;Identification du constructeur de la cpu
   mov dword ptr chaine,ebx
   mov dword ptr chaine+4,edx
   mov dword ptr chaine+8,ecx
   mov dx,ds
   mov ax,offset chaine
    .endif

    .if (nbr==1)
   mov eax,1 ; dtrminer l'ID de la cpu
   cpuid
   mov dword ptr chaine,eax
   mov dx,ds
   mov ax,offset chaine
    .endif

    .if (nbr==2) ; calculer la frquence d'horloge de la cpu
    .186
    cld
    in al,21h                ; lire l'tat du master 8259A
    mov ah,al
    in al,0A1h               ; lire l'tat de l'sclave
    push ax                  ;  sauver dans la pile l'tat du controleur d'IT
    mov al,0FEh              ; valeur pour inhiber toutes les IT mis  part celle du timer (IRQ 0)
    out 21h,al
    mov al,0FFh              ; inhiber toutes les IT sur l'sclave
    out 0A1h,al
    ; ceci fait, on attend l'arrive du signal d'horlogle grace  (hlt)
    sti
    hlt
    .586
    rdtsc                    ; l'instruction ci contre rcupre dans eax le nombre de cycles d'horloges (partie  faible), et dans edx la partie forte  
    mov ebx,eax              ;sauver temporairement
    mov ecx,edx
                              ; refaire l'tape prcedente
    hlt                      ; attente du timer
    rdtsc
    sub eax,ebx              ;diffrence de la partie basse
    sbb edx,ecx              ;diffrence de la patrie haute avec la retenue
    mov ebx,eax
    .186
    pop ax
    cli
    out 0A1h,al              ;restaurer l'tat du contrelleur d'IT
    mov al,ah
    out 21h,al

    jmp $+2
    jmp $+2

    mov al,20h
    out 20h,al
    out 0a0h,al

    .386
    mov dword ptr chaine,ebx
    mov dword ptr chaine+4,edx
    mov dx,ds
    mov ax,offset chaine     ;pointeur sur chane comme valeur de retour 
    
  .endif
  .data
  chaine dd 0
         dd 0
         dd 0
         db 0
         .code
ret
init_cpu endp

end
