/*
                 Copyright(c) 2005 Toufik Sarni

This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA*/


#include <kernel.h>
#include <proc.h>

SEMAPHORE R1;
SEMAPHORE R2;


thread1()
 {
  suspendre_tache_delai(1000);
  P(R2);
  suspendre_tache_delai(2000);
  P(R1);
  suspendre_tache_delai(2000);
  V(R1);
  V(R2);
  asm cli;
 }

thread2()
 {
  suspendre_tache_delai(1000);
  P(R1);
  suspendre_tache_delai(4000);
  P(R2);
  suspendre_tache_delai(2000);
  V(R2);
  V(R1);
 }


void application_tr()
 {
  int i;

   R1=creer_semaphore();
   R2=creer_semaphore();

   add_semaphore(0,R1,2);   //(la file 0, smaphore R1, temps d'excution de la SC: 2units de temps)
   add_semaphore(0,R2,4);   

   add_semaphore(1,R1,5);   //(la file 1, smaphore R1, temps de la SC: 5units de temps)
   add_semaphore(1,R2,2);   


  i=creer_tache((THREAD)&thread1,4,5,100,0/*file 0 des smaphores  utiliser*/);
  if (i<0) print_rt("Erreur -%d: Cration de Tache0\n",-i);
    else print_rt("Tche %d priodique. Ressources  utiliser R2 et R1\n",i);

  i=creer_tache((THREAD)&thread2,1,6,101,1);
  if (i<0) print_rt("Erreur -%d: Cration de Tache1\n",-i);
      else print_rt("Tche %d priodique. Ressources  utiliser R1 et R2\n",i);


  i=faisabilite();       //teste la faisabilit RM avec prise en compte du facteur de blocage
  if (i<0) print_rt("Faisabilit erreur: -%d\n",-i);
      else print_rt("Faisabilit ... OK\n");

  print_rt("priorite de tache[0]: %d Facteur de blocage Bi=%d\n",tache[0].priorite,tache[0].sched.Bi);
  print_rt("priorite de tache[1]: %d Facteur de blocage Bi=%d\n",tache[1].priorite,tache[1].sched.Bi);

   activer_horloge();   // activer l'horloge temps rel et lancement du systme de tches temps rel.
   while(1);

 }
