#include "kernel.h"

struct super_struct_setup{

         struct stcpu{
         const char _fptr *nom_cpu[5];
         const char _fptr *id_cpu[3];
             struct stfrq_cpu{
                    unsigned long a;
                    unsigned long b;
                             }frqcpu;
          }initcpu;

          struct stram{
          unsigned long extd_ram,base_mem;
          }initram;

          struct stconfig{
          unsigned int config;
          }initconfig;

          struct stdisquette{
          unsigned char type;
          unsigned char nbr_lecteur;
          unsigned char nbr_secteur;
          unsigned char nbr_tete;
          unsigned char nbr_cylindre;
          }initdisquette;

          struct stdisquedur{
          unsigned char nbr_lecteur;
          unsigned char nbr_secteur;
          unsigned char nbr_tete;
          unsigned int  nbr_cylindre;
          }initdisquedur;

                  };

#define cpu superstruct->initcpu
#define ram superstruct->initram
#define disque_dur  superstruct->initdisquedur
#define disquette   superstruct->initdisquette
//////////////////////////////////////////////////////
// le format de d'adresse logique d' i386
//  --------------------------------------------------------------------------------------------------
//  |  10-bit pour le rprtoire des pages (PGD) |  10-bit, pour table des pages | 12-bit dplacement |
//  --------------------------------------------------------------------------------------------------
//  d'o les macros suivants:

#define align_adr_page(x)    ((x)-((x)&(0xFFF)))     //aligner l'adresse x  celle de sa page correspondante
#define num_pgt(x)    (((x) & 0x3FF000)>>12)        //renvoie le numro de page (table des page)
#define num_pgd(x)    (((x) & 0xFFC00000)>>22)      //renvoie le numro du rpertoire des pages


