/*
                 Copyright(c) 2005 Toufik Sarni

This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA*/

#include <stdio.h>
#include <stdlib.h>
#include <io.h>
#include <fcntl.h>

int _write_sect(unsigned char cyl,unsigned char tete,unsigned char sect,
                char far *ptr);

char buffer[512];
unsigned long pos=0;

int main(int argc, char *argv[])
{
  printf("\nChargeur de fichier sur disque, version 1.0, par Toufik SARNI.\n");
 if (argc!=2)
   {
    printf("\nUsage: chargeur [path fichier]\n");
    return 1;
   }
int handle1 = open(argv[1], O_RDONLY);
if (handle1 <0)
   {
    printf("Erreur d'ouverture du fichier: %s\n",argv[1]);
    return 1;
   }
unsigned long taille1= (unsigned long)filelength(handle1);
close(handle1);     
  if (taille1>1456128)
     {
     printf("Fichier trop grand!\n");
     return 1;
     }


  FILE *file1;

  if ((file1=fopen(argv[1],"rb"))==NULL)
     {
     printf("Impossible d'ouvrir le fichier: %s",argv[1]);
     return 1;
     }

  unsigned short int cyl,tete,sect;

  for (cyl=0;cyl<=79;cyl++)
  {
    for (tete=0;tete<=1;tete++)
      {
        for (sect=1;sect<=18;sect++)
          {
           if ((pos +512)<=taille1)
           {
           fread((void *)&buffer[0],512,1,file1);
           if (_write_sect(cyl,tete,sect,(char far *)&buffer[0]))
               { printf("\nErreur d'criture sur la disquette.\n");
                 return 1;
               }
           printf(".");
           pos +=512;
           fsetpos(file1,(const long *)&pos);
           }
           else
           {
           if ((taille1-pos)>0)
             {
             fread((void *)&buffer[0],(taille1-pos),1,file1);
             if (_write_sect(cyl,tete,sect,(char far *)&buffer[0]))
               {
                 printf("\nErreur d'criture sur la disquette.\n");
                 return 1;
               }
             printf(".");
             goto fin;
             }
           else goto fin;

           }


          }
      }
  }
fin:
printf("OK\n");
}

int _write_sect(unsigned char cyl,unsigned char tete,unsigned char sect,
                char  far *p)
   {
     asm{
         push ax
         push bx
         push cx
         push dx

         mov ah,03   // fonction d'criture
         mov al,1    // 1 secteur
         mov ch,byte ptr cyl
         mov cl,byte ptr sect
         mov dh,byte ptr tete
         mov dl,0    // unit de disquette
         les  bx,dword ptr p
         int 0x13
         jnc suite

         pop dx
         pop cx
         pop bx
         pop ax

         mov ax,1     // il y a erreur
         jmp err
    suite:
         pop dx
         pop cx
         pop bx
         pop ax
         xor ax,ax
   err:
         }
  }
