/*
                 Copyright(c) 2005 Toufik Sarni

This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA*/

#include <kernel.h>
u8 inpb(u16 port)
 {
  u8 i;
  asm
  { push ax
    push dx
    mov dx,word ptr port
    in al,dx
    mov i,al
    pop dx
    pop ax
  }
 return i;
 }
void outpb(u16 port, u8 val)
 {
  asm
  { push ax
    push dx
    mov dx,word ptr port
    mov al,val
    out dx,al
    pop dx
    pop ax
  }
 }
#ifdef TEMPS_REEL
/*extern char buffer_clavier[256];
extern char *bot_buffer_clavier;
extern char *top_buffer_clavier;

char getchar()
{
  char c;
  //extraction d'un caractre du buffer clavier

  if  (bot_buffer_clavier!=top_buffer_clavier)
       //print_rt("bot:%p top:%p &buff:%p\n",bot_buffer_clavier,top_buffer_clavier,&buffer_clavier[0]);
       return *(bot_buffer_clavier++);
      
   else  
        {
         bot_buffer_clavier=top_buffer_clavier=&buffer_clavier[0];
         //print_rt("getchar: buffer vide\n");
         while(bot_buffer_clavier==top_buffer_clavier); //attente d'une insertion d'un caractre
         return *(bot_buffer_clavier++);
         } 
return 0;
}*/
#endif

void borland_ftol()
{
asm{
 __ftol:
   push ebp
   mov  ebp,esp
   lea esp,dword ptr[ebp-0ch]
   wait
   fnstcw word ptr [ebp-4]
   wait
   mov al,byte ptr [ebp-3]
   or byte ptr [ebp-3],0ch
   fldcw word ptr [ebp-4]
   fistp qword ptr [ebp-0ch]
   mov [ebp-3],al
   fldcw word ptr [ebp-4]
   mov eax,dword ptr[ebp-0ch]
   mov esp,ebp
   pop ebp
   ret
public __ftol
  }
}  
